/* *******************************************************************
 * File : mm.h 
 * Date : 2007/ 04/ 04
 * Written by : Sun Joon Gyu
 * Purpose : Header for Memory management 
*********************************************************************/

#ifndef	_MM_H_
#define _MM_H_

#include"types.h"


/* These definition is temporarily used here */
#define MEM_COMPACTION 
/*********************************************/



/**** These definitions should be moved to hardware dependant code    ********/
#define START_HEAP_ADDR		((unsigned int *)heap)/* proper address should be described here!! */
#define END_HEAP_ADDR		((unsigned int *)((char *)heap+SIZE_OF_HEAP))/* proper address should be described here!! */
#define BLOCK_SIZE		(sizeof(struct memHead))/* Size of one block			    */ 
#define SIZE_OF_HEAP		(1024*1024)
/*****************************************************************************/ 

#define SIZE_OF_BYTE		 8
#define BACKWARD		 0
#define FORWARD			 1



/* Definition for type of memory control block */
typedef struct memHead {
	struct memHead *pPrev;	
	unsigned int size;
	struct memHead *pNext;
	struct memHead *pAllocNext;	/* it indicates next allocated block */
	struct memHead *pAllocPrev;
	unsigned int threadID;
	unsigned int status;
	
#ifdef MEM_COMPACTION
	unsigned int *pVar;	/*the size of a tcb will be expanded if MEM_COMPACTION is defined */
#endif // MEM_COMPACTION
} memHead_t, *pMemHead_t;



char Kern_MemInit();
unsigned int *MemAlloc(unsigned int *pReqVar, size_t size);
pMemHead_t Kern_WantedBlkFind(size_t size);
char Kern_MemBlkGet(pMemHead_t pBlkAddr, size_t size);

char MemRelease(void *pDesired);
char Kern_MemMerge(pMemHead_t pPrevBlk, pMemHead_t pNextBlk,unsigned char dir);
	
char Kern_BlkTblRegister(unsigned int *pReqVar,pMemHead_t pBlkAddr);


	
#endif // _MM_H_ 
