#include<stdio.h>
#include"elfos.h"
#include"../mm/mm.h"
#include "../list/semaphore.h"

extern void mm_TimerStart();
extern unsigned int *pHeadList_g;
void task1();
void task2();
void task3();

pEventQueue pEventQ;
EventListNode *sem_g;

int Start_ElfOS()
{
	Port_Init();
	Kern_Init();
	Kern_BlockedListInit();

	printf("available memory : %d \n", ((memHead_t *)pHeapList_g)->size);

	Kern_RegisterDev(0,NULL,NULL,NULL,&printf,NULL,NULL,NULL);   /* this is temporaly put for examination */

	pEventQ = EventQueueCreate();
	sem_g = SemCreate(pEventQ, 1);
	Kern_ThreadCreate(&task1,1,1);
	Kern_ThreadCreate(&task2,2,2);
	Kern_ThreadCreate(&task3,3,3);

	Kern_SchedulerStart();
	while(1){;}
}


int main()
{
	Start_ElfOS();
}



void task1()
{
	mm_TimerStart();

	int i;
	char err;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);

	SemPend(sem_g);

		while(1) {
			for(i=0; i < 10000; i ++){
				usleep(100000);
				console->Write("task1 : %d \n",i);

				if(i == 100) {
					SemPost(sem_g);
				}
			}
		}
}


void task2()
{
	int i;
	char err;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);

	SemPend(sem_g);

		while(1) {
			for(i=0; i < 10000; i ++){
				usleep(100000);
				console->Write("task2 : %d \n",i);

				if(i == 100) {
					SemPost(sem_g);
				}
			}
		}
}

void task3()
{
	int i;
	char err;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);

	SemPend(sem_g);

		while(1) {
			for(i=0; i < 10000; i ++){
				usleep(100000);
				console->Write("task3 : %d \n",i);

				if(i == 100) {
					SemPost(sem_g);
				}
			}
		}
}
