/***************************************************************** 
 * File        : elfos.c 
 * Date        : 2007/ 03/ 05
 * Author      : Sun Joon Gyu
 * Modified    : 2007/ 05/ 27
 * Description : This file is to write down application program with ElfOS Kernel
 * *****************************************************************/
#include<stdio.h>
#include"elfos.h"
#include"../mm/mm.h"
#include"../object/pipe.h"

extern void mm_TimerStart();
extern unsigned int *pHeadList_g;
void task1();
void task2();
void task3();
void task4();
void task5();




/*************************************************************************** 
 * Function    : Start_ElfOS() 
 * Date        : 2007/03/05
 * Author      : Sun Joon Gyu
 * Parameter   : 
 * Return value: Never return
 * Description :  
 * ***************************************************************************/
int Start_ElfOS()
{
	Port_Init();
	Kern_Init();

	printf("available memory : %d \n", ((memHead_t *)pHeapList_g)->size);

	/* this is temporaly put for examination */
	Kern_RegisterDev(0,NULL,NULL,NULL,&printf,NULL,NULL,NULL);  


#if 0
	Kern_InitPipeOp();
#endif


	Kern_ThreadCreate(&task1,1,1);
	Kern_ThreadCreate(&task2,2,2);

	Kern_ThreadCreate(&task3,3,3);
	Kern_ThreadCreate(&task4,4,4);
	Kern_ThreadCreate(&task5,5,5);
	Kern_SchedulerStart();
	while(1){;}
}



/*************************************************************************** 
 * Function    : main()
 * Date        : 2007/03/05
 * Author      : Sun Joon Gyu
 * Parameter   : 
 * Return value:
 * Description : This function is temporary used for linux port.
 * ***************************************************************************/

int main()
{
	Start_ElfOS();
}



/*************************************************************************** 
 * Function    : task1()
 * Date        : 2007/03/05
 * Author      : Sun Joon Gyu
 * Parameter   : 
 * Return value:
 * Description : This is first task to test if ElfOS kernel works correctly.
 * ***************************************************************************/

void task1()
{
	mm_TimerStart();

	int i;
	int j = 0;
	int k = 0;
	int *p;
	char err;
	pipe_t *pipe;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);
	p = MemAlloc(&p,1024 * 900);
	
	
	CreatePipe(1,256);
	pipe = OpenPipe(1,256);
	WriteToPipe(pipe,"sunjoongyu\n",11);
	

	while(1){
		for(i=0; i < 10000; i ++){
			usleep(100000);
			console->Write("task1 : %d \n",i);

			
		}
	}
				
	
}



void task2()
{
	int i;
	int j = 0;
	int k = 0;
	char err;
	char buff[250];
	dev_op_t *console;
	pipe_t *pipe;
	console = Kern_GetDevOp(0,&err);
	
	pipe = OpenPipe(1,256);
	console->Write("pid: %d\n",pipe->pid);
	ReadFromPipe(pipe,buff,11);
	buff[12] = '\0';
	console->Write("\n\n\n %s \n",buff );

	while(1){
		for(i=0; i < 10000; i ++){
			usleep(100000);

			console->Write("task2 : %d \n",i);
			
			if((i+1) % 20 == 0){
				Sleep(10);
			}
			

		}
	}
				
	
}

void task3()
{
	int i;
	int j = 0;
	int k = 0;
	char err;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);

	while(1){
		for(i=0; i < 10000; i ++){
			usleep(100000);

			console->Write("task3 : %d \n",i);
		}
	}
				
	
}

void task4()
{
	int i;
	int j = 0;
	int k = 0;
	char err;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);

	while(1){
		for(i=0; i < 10000; i ++){
			usleep(100000);

			console->Write("task4 : %d \n",i);

			if((i+1) % 20 == 0){
				Sleep(10);
			}
		}
	}
				
	
}

void task5()
{
	int i;
	int j = 0;
	int k = 0;
	char err;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);

	while(1){
		for(i=0; i < 10000; i ++){
			usleep(100000);

			console->Write("task5 : %d \n",i);
		}
	}
				
	
}


