#include<stdio.h>
#include"elfos.h"
#include"../mm/mm.h"
#include "../list/semaphore.h"

extern void mm_TimerStart();
extern unsigned int *pHeadList_g;
void task1();
void task2();

EventQueue EventQ;
EventListNode *sem_g;

int Start_ElfOS()
{
	Port_Init();
	Kern_Init();

	printf("available memory : %d \n", ((memHead_t *)pHeapList_g)->size);

	Kern_RegisterDev(0,NULL,NULL,NULL,&printf,NULL,NULL,NULL);   /* this is temporaly put for examination */

	EventQ = EventQueueCreate();
	sem_g = SemCreate(EventQ, 1);
	Kern_ThreadCreate(&task1,1,1);
	Kern_ThreadCreate(&task2,2,2);

	Kern_SchedulerStart();
	while(1){;}
}


int main()
{
	Start_ElfOS();
}



void task1()
{
	mm_TimerStart();

	int i;
	int j = 0;
	int k = 0;
	int *p;
	char err;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);
	p = MemAlloc(&p,1024 * 900);

	while(1) {
		if(SemPend(sem_g) == 0) {
			for(i=0; i < 10000; i ++){
				usleep(100000);
				console->Write("task1 : %d \n",i);

				if(i == 100) {
					SemPost(sem_g);
					Kern_Sched();
					break;
				}
			}
		} else if(tempstop_g == 0) {
		    tempstop_g = 1;
			Kern_Sched();
		}
	}
}


void task2()
{
	int i;
	int j = 0;
	int k = 0;
	char err;
	dev_op_t *console;
	console = Kern_GetDevOp(0,&err);

	while(1) {
		if(SemPend(sem_g) == 0) {
			for(i=0; i < 10000; i ++){
				usleep(100000);
				console->Write("task2 : %d \n",i);

				if(i == 20) {
					SemPost(sem_g);
					Kern_Sched();
					break;
				}
			}
		} else {
			Kern_Sched();
		}
	}
}

