#include"vfs.h"
#include"../../mm/mm.h"
#include"../../types/types.h"

char 
Kern_RegisterDev(unsigned char devNum,void *Dev_Create,void *Dev_Open, void *Dev_Read,
		void *Dev_Write, void *Dev_Close, void *Dev_Ioctl,void *Dev_Destroy)
{
	if(pDevTable_g[devNum] == NULL){
		pDevTable_g[devNum] = (dev_op_t *)MemAlloc((unsigned int *)&(pDevTable_g[devNum]),(size_t)sizeof(struct device_operation));

		dev_op_t *pDev_Op = (dev_op_t *)pDevTable_g[devNum];

		pDev_Op->Create = (int (*)()) Dev_Create; 
		pDev_Op->Open = (int (*)()) Dev_Open;
		pDev_Op->Read = (int (*)()) Dev_Read;
		pDev_Op->Write = (int (*)()) Dev_Write;
		pDev_Op->Close = (int (*)()) Dev_Close;
		pDev_Op->Ioctl = (int (*)()) Dev_Ioctl;
		pDev_Op->Destroy = (int (*)()) Dev_Destroy;
	}else {
		return FAILED;
	}

	return SUCCESS;
}

char
Kern_DeallocDev(unsigned char devNum)
{
	if(pDevTable_g[devNum] != NULL){
		MemRelease(pDevTable_g[devNum]);
		pDevTable_g[devNum] = NULL;

	}else {
		return FAILED;
	}

	return SUCCESS;
}

dev_op_t *Kern_GetDevOp(unsigned char devNum, char *err)
{
	if(pDevTable_g[devNum] != NULL){
		*err = NOERR;
		return pDevTable_g[devNum];
	}else {
		*err = NODEV;
		return NULL;
	}
}
