/*************************************************************************** 
 * File        : interrupt.c
 * Date        : 2007/03/05
 * Author      : Sun Joon Gyu
 * Modified    : 2007/05/27     
 * Description : 
 * ***************************************************************************/
#include"../thread/thread.h"
#include"../lib/list.h"
#include"../scheduler/scheduler.h"
#define QUANTUM_TIME	5	

extern unsigned int quantum_g;
extern waitList_t *pBlockedList_g;





/*************************************************************************** 
 * Function    : Kern_TickISR()
 * Date        : 
 * Author      : 
 * Parameter   : 
 * Return value:
 * Description : 
 * ***************************************************************************/

void Kern_TickISR()
{
	tcb_t *iter;

	if(!ListEmpty(&pBlockedList_g->threadList)){
		ListForEachEntry(iter,&pBlockedList_g->threadList,threadList){
			iter->tickDly--;
			printf("tickDly = %d \n", iter->tickDly);

			if(iter->tickDly == 0){
				struct list_head *tempList = iter->threadList.prev;

				Kern_WakeThread(iter);

				iter = tempList;

			}

		}
	}
	printf("tick : %d\n",quantum_g);
	if(++quantum_g < QUANTUM_TIME){
		return;
	}
	else{
		Kern_Sched();
	}
}
