/*************************************************************************** 
 * File        : iosubsys.h
 * Date        : 2007/04/25
 * Author      : Sun Joon Gyu
 * Modified    : 2007/04/25
 * Description : 
 * ***************************************************************************/
#ifndef _IOSUBSYS_H_
#define _IOSUBSYS_H_

#define MAX_DEVICES	255
#define NOERR	1	
#define NODEV	-1


typedef struct device_operation {
	int (*Create)();
	int (*Open)();
	int (*Read)();
	int (*Write)();
	int (*Close)();
	int (*Ioctl)();
	int (*Destroy)();
}dev_op_t;


dev_op_t *pDevTable_g[MAX_DEVICES];


char 
Kern_RegisterDev(unsigned char devNum,void *Dev_Create,void *Dev_Open, void *Dev_Read,
		void *Dev_Write, void *Dev_Close, void *Dev_Ioctl,void *Dev_Destroy);

char
Kern_DeallocDev(unsigned char devNum);

dev_op_t *
Kern_GetDevOp(unsigned char devNum, char *err);

#endif //_IOSUBSYS_H_
