#include "queue.h"

pQueue QueueCreate(void)
{
	pQueue pQ = malloc(sizeof(struct queue));

	if(pQ != NULL)
		pQ->pFront = pQ->pRear = NULL;

	return pQ;
}

void Enqueue(pQueue pQ, void *pData)
{
	ListNode *pNewNode = ListNodeCreate(pData, NULL);

	if(pQ->pFront == NULL)
		pQ->pFront = pNewNode;
	else
		pQ->pRear->pNext = pNewNode;

	pQ->pRear = pNewNode;
}

void *Dequeue(pQueue pQ)
{
	ListNode *pFirstNode = pQ->pFront;
	void *pData = pFirstNode->pData;

	if((pQ->pFront=pFirstNode->pNext) == NULL)
		pQ->pRear = NULL;

	free(pFirstNode);

	return pData;
}

pEventQueue EventQueueCreate(void)
{
	pEventQueue pQ = malloc(sizeof(struct eventqueue));

	if(pQ != NULL)
		pQ->pFront = pQ->pRear = NULL;

	return pQ;
}

void EventEnqueue(pEventQueue pQ, EventListNode *pNode)
{
	if(pQ->pFront == NULL)
		pQ->pFront = pNode;
	else
		pQ->pRear->pNext = pNode;

	pQ->pRear = pNode;
}

void *EventDequeue(pEventQueue pQ)
{
	EventListNode *pFirstNode = pQ->pFront;

	if((pQ->pFront=pFirstNode->pNext) == NULL)
		pQ->pRear = NULL;

	free(pFirstNode);
}

/*
int main()
{
    char *test = malloc(1024);

    Queue testQ;
    testQ = QueueCreate();

    test = "1";
    Enqueue(testQ, test);
    test = "2";
    Enqueue(testQ, test);
    printf("%s\n", Dequeue(testQ));
    printf("%s\n", Dequeue(testQ));

    return 0;
}
*/
