#include "semaphore.h"
#include "../lib/list.h"

pEventList SemCreate(pEventQueue pEventQ, int cnt)
{
	EventEnqueue(pEventQ, EventListNodeCreate(1, cnt, NULL, pEventQ->pFront));
	INIT_LIST_HEAD(&pEventQ->pRear->blockedList.threadList);

	return pEventQ->pRear;
}

static void traceTCB(struct list_head * list)
{
	list = list->next;
	while(list != &pRdyListHead_g->threadList){
		printf("ThreadList : %p \n",list->next);
		list = list->next;
	}

}


char SemPend(pEventList sem)
{
    // Enter Critical Section
	tcb_t *curr = Kern_GetCurrThread();

	if(sem->eventCnt > 0)
	{
		sem->eventCnt--;
		printf("*** Getting a semaphore ***\n");
    // Exit Critical Section
		return 0;
	}

    // Set Current TCB's state to Semaphore
	// Suspend current thread and move waiting list
	printf("*** Failure to get a semaphore ***\n");


	traceTCB(&pRdyListHead_g->threadList);
	
	printf("SemPend : Curr - %p \n", &curr->threadList);
	printf("SemPend : RdyList- %p \n", &pRdyListHead_g->threadList);
	printf("SemPend : RdyList.next- %p \n", pRdyListHead_g->threadList.next);
  	pNextThread_g = ListEntry(pRdyListHead_g->threadList.next,tcb_t,threadList);

	printf("SemPend : pNextThread - %p \n", &pNextThread_g->threadList);

	Kern_BlockThread(curr, &(sem->blockedList));

	printf("SemPend : RdyList.next - %p \n", pRdyListHead_g->threadList.next);

  	quantum_g = 0;
	//Port_ThreadSwitch();
	Kern_Sched();

	return 1;
}

char SemPost(pEventList sem)
{
    // Enter Critical Section
	sem->eventCnt++;
	printf("*** Posting a semaphore ***\n");
    // Exit Critical Section

	// See if any task wating for semaphore
	// Hightest priority task ready to run

	if( (sem->blockedList.threadList.next) != (&sem->blockedList.threadList)) {
		tcb_t *tmpThread = ListEntry(sem->blockedList.threadList.next, tcb_t, threadList);
		Kern_WakeThread(tmpThread);

		//Kern_Sched();
	}

	return 0;
}

/*
int main()
{
    pEventQueue pEventQ;
	EventListNode *sem;
    pEventQ = EventQueueCreate();

	sem = SemCreate(pEventQ, 1);
	sem = SemCreate(pEventQ, 2);
    printf("%d\n", sem->eventCnt);
	EventDequeue(pEventQ);
    printf("%d\n", pEventQ->pFront->eventCnt);

    return 0;
}
*/
