#ifndef _THREAD_H_
#define _THREAD_H_

#include "../mm/mm.h"
#include "../types/types.h"
#include "../lib/list.h"


#define STACK_SIZE 4096


typedef void (*fpThread_t)(void *);

typedef struct tcb
{
  stack_t *pTopOfStack;
  
  struct list_head threadList;

#if 0  
  struct tcb *pNext;
  struct tcb *pPrev;
#endif

  prior_t prior;
  stack_t *pStack;
  tickCnt_t tickDly;
  tid_t tid;
  pMemHead_t pMemList;
} tcb_t, *ptcb_t;


extern tcb_t *pRdyListHead_g;
extern tcb_t *pRdyListTail_g;


extern ptcb_t Kern_ThreadCreate(fpThread_t, prior_t, tid_t);		// Thread Creation


#endif // _THREAD_H_
