/* File : mm.h 
 * Date : 2007/ 04/ 04
 * Written by : Sun Joon Gyu
 * Purpose : Header for Memory management 
*/

#ifndef	MEM_MANAGEMENT
#define MEM_MANAGEMENT


/* These definition is temporarily used here */
typedef unsigned int	size_t;
typedef unsigned char	index_t;
/*********************************************/
 



/**** These definitions should be moved to hardware dependant code    ********/
#define START_HEAP_ADDR		((unsigned int *)heap)/* proper address should be described here!! */
#define END_HEAP_ADDR		((unsigned int *)((char *)heap+SIZE_OF_HEAP))/* proper address should be described here!! */
#define BLOCK_SIZE		(sizeof(struct memHead))/* Size of one block			    */ 
#define SIZE_OF_HEAP		(1024*1024)
#define NULL			0
#define MEM_COMPACTION
/*****************************************************************************/ 

#define REG_FAILED		-2	/* Registration to block table for compaction failed */
#define FAILED			-1
#define SUCCESS			 1
#define ALLOCATED		 0
#define AVAILABLE		 1
#define SIZE_OF_BYTE		 8

/* Definition for type of memory control block */
typedef struct memHead {
	struct memHead *pPrev;	
	unsigned int size;
	struct memHead *pNext;
	unsigned int threadID;
	unsigned int status;
#ifdef MEM_COMPACTION
	/*the size of a tcb will be expanded if MEM_COMPACTION is defined */
//	struct memHead *pAllocPrev;	
	unsigned int *pVar;	
//	struct memHead *pAllocNext;
#endif // MEM_COMPACTION
} memHead_t, *pMemHead_t;



char Kern_MemInit();
unsigned int *MemAlloc(unsigned int *pReqVar, size_t size);
pMemHead_t Kern_WantedBlkFind(size_t size);
char Kern_MemBlkGet(pMemHead_t pBlkAddr, size_t size);

char MemRelease(unsigned int *pDesired);

#ifdef	MEM_COMPACTION
/*Functions for memory compaction */
char Kern_BlkTblRegister(unsigned int *pReqVar,pMemHead_t pBlkAddr);

#endif /* MEM_COMPACTION */







	
#endif // MEM_MANAGEMENT 
